/*******************************************************************************
 * FoxCustomizationNode_GearBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxCustomizationNode_GearBase extends FoxCustomizationNode_Base within FoxArmoryUI
    abstract
    native(UI)
    config(UI);

struct native GearInfo
{
    var UIResourceDataProvider GearProvider;
    var int GearIndex;
    var FoxTypes.ETacticalGearType TacticalTypeID;

    structdefaultproperties
    {
        GearProvider=none
        GearIndex=0
        TacticalTypeID=ETacticalGearType.ETGT_None
    }
};

var transient array<GearInfo> GearInfoArray;

function Initialize(optional bool bSelectEquipped)
{
    local ScrollerListEntry NewScrollerListEntry;
    local array<UIResourceDataProvider> NewGearArray;
    local int I, CurrentIndex;
    local GearInfo NewGearInfo;

    bSelectEquipped = true;
    super.Initialize(bSelectEquipped);
    SetupCustomItemType(NewGearArray, bSelectEquipped);
    Outer.SelectedScrollerIndex = 0;
    CurrentIndex = GetCurrentIndex();
    GearInfoArray.Length = 0;
    ScrollerEntries.Length = 0;
    Outer.ApplySelectedNodeSocket(Outer.CustomItemType);
    I = 0;
    J0xCA:
    // End:0x37D [Loop If]
    if(I < NewGearArray.Length)
    {
        // End:0x36F
        if(SetScrollerEntry(NewScrollerListEntry, FoxDataProvider_GearInfo(NewGearArray[I]).UnlockID))
        {
            NewGearInfo.GearProvider = NewGearArray[I];
            NewGearInfo.GearIndex = I;
            NewGearInfo.TacticalTypeID = FoxDataProvider_GearInfo(NewGearArray[I]).TacticalTypeID;
            // End:0x2D5
            if(Outer.CachedGearSlot.bFemale && FoxDataProvider_GearInfo(NewGearArray[I]).FImageIconRef != "")
            {
                NewScrollerListEntry.sIcon = Outer.Outer.Outer.MarkupImageString(FoxDataProvider_GearInfo(NewGearArray[I]).FImageIconRef);
            }
            NewScrollerListEntry.InsertIndex = GearInfoArray.Length;
            // End:0x343
            if(NewGearInfo.GearIndex == CurrentIndex)
            {
                SetEquipped(NewScrollerListEntry, bSelectEquipped);
            }
            ScrollerEntries.AddItem(NewScrollerListEntry);
            GearInfoArray.AddItem(NewGearInfo);
        }
        ++ I;
        // [Loop Continue]
        goto J0xCA;
    }
    EquippedUnlockID = FoxDataProvider_GearInfo(NewGearArray[CurrentIndex]).UnlockID;
    SetupScrollerBar(bSelectEquipped);
    //return;    
}

// Export UFoxCustomizationNode_GearBase::execSetEntryToOwned(FFrame&, void* const)
native function SetEntryToOwned(out ScrollerListEntry Entry);

function PrestreamIndex(int iIndex, bool bStreamIn)
{
    FoxDataProvider_GearInfo(GearInfoArray[ScrollerEntries[iIndex].InsertIndex].GearProvider).Prestream(bStreamIn, FoxPRI(Outer.Outer.Outer.PCOwner.PlayerReplicationInfo));
    //return;    
}

function int GetCurrentIndex()
{
    switch(Outer.CustomItemType)
    {
        // End:0x63
        case 0:
            return Outer.SavedGearSlot.HelmetID;
            // End:0x27F
            break;
        // End:0x9E
        case 1:
            return Outer.SavedGearSlot.UpperBodyID;
            // End:0x27F
            break;
        // End:0xDA
        case 2:
            return Outer.SavedGearSlot.LowerBodyID;
            // End:0x27F
            break;
        // End:0x114
        case 3:
            return Outer.SavedGearSlot.BadgeID;
            // End:0x27F
            break;
        // End:0x150
        case 4:
            return Outer.SavedGearSlot.BodyCamoID;
            // End:0x27F
            break;
        // End:0x18C
        case 10:
            return Outer.SavedGearSlot.Gear_R1ID;
            // End:0x27F
            break;
        // End:0x1C8
        case 11:
            return Outer.SavedGearSlot.Gear_L1ID;
            // End:0x27F
            break;
        // End:0x204
        case 12:
            return Outer.SavedGearSlot.Gear_R2ID;
            // End:0x27F
            break;
        // End:0x240
        case 13:
            return Outer.SavedGearSlot.Gear_L2ID;
            // End:0x27F
            break;
        // End:0x27C
        case 9:
            return Outer.SavedGearSlot.TacticalID;
            // End:0x27F
            break;
        // End:0xFFFF
        default:
            //return ReturnValue;
    }
}
}

function bool ApplySelectedUnlock(int GearIndex, out ProfileGearInfo GearToChange)
{
    local int PrevGearID;

    switch(Outer.CustomItemType)
    {
        // End:0x7F
        case 0:
            PrevGearID = GearToChange.HelmetID;
            GearToChange.HelmetID = byte(GearIndex);
            // End:0x33F
            break;
        // End:0xD6
        case 1:
            PrevGearID = GearToChange.UpperBodyID;
            GearToChange.UpperBodyID = byte(GearIndex);
            // End:0x33F
            break;
        // End:0x12E
        case 2:
            PrevGearID = GearToChange.LowerBodyID;
            GearToChange.LowerBodyID = byte(GearIndex);
            // End:0x33F
            break;
        // End:0x182
        case 3:
            PrevGearID = GearToChange.BadgeID;
            GearToChange.BadgeID = GearIndex;
            // End:0x33F
            break;
        // End:0x1DA
        case 10:
            PrevGearID = GearToChange.Gear_R1ID;
            GearToChange.Gear_R1ID = byte(GearIndex);
            // End:0x33F
            break;
        // End:0x232
        case 11:
            PrevGearID = GearToChange.Gear_L1ID;
            GearToChange.Gear_L1ID = byte(GearIndex);
            // End:0x33F
            break;
        // End:0x28A
        case 12:
            PrevGearID = GearToChange.Gear_R2ID;
            GearToChange.Gear_R2ID = byte(GearIndex);
            // End:0x33F
            break;
        // End:0x2E2
        case 13:
            PrevGearID = GearToChange.Gear_L2ID;
            GearToChange.Gear_L2ID = byte(GearIndex);
            // End:0x33F
            break;
        // End:0x33A
        case 9:
            PrevGearID = GearToChange.TacticalID;
            GearToChange.TacticalID = byte(GearIndex);
            // End:0x33F
            break;
        // End:0xFFFF
        default:
            return false;
    }
    return PrevGearID != GearIndex;
    //return ReturnValue;    
}

function GenerateDetails()
{
    Outer.GenerateArmorDetails();
    //return;    
}

function UpdateNodeDetails()
{
    local array<Vector2D> NewStats;

    Outer.UpdateSelectedArmorStats(NewStats);
    Outer.DisplayArmorStats(NewStats);
    //return;    
}

function ResetSelectedLoadout()
{
    Outer.RebuildCachedGearInfo();
    Outer.Outer.ArmoryInfo.loadPreviewActor();
    //return;    
}

function SetupCustomItemType(out array<UIResourceDataProvider> NewGearArray, bool bReset)
{
    //return;    
}

function ei_changeScrollerIndex(int Index)
{
    local int SelectedGearIndex;
    local ProfileGearInfo TempGearSlot;

    // End:0x14D
    if((Index >= 0) && Index < ScrollerEntries.Length)
    {
        TempGearSlot = Outer.CachedGearSlot;
        SelectedGearIndex = GearInfoArray[ScrollerEntries[Index].InsertIndex].GearIndex;
        Outer.SelectedGearInfo = FoxDataProvider_GearInfo(GearInfoArray[ScrollerEntries[Index].InsertIndex].GearProvider);
        ApplySelectedUnlock(SelectedGearIndex, TempGearSlot);
        Outer.UpdateCharacterGear(TempGearSlot);
    }
    super.ei_changeScrollerIndex(Index);
    //return;    
}

function ei_ScrollerClicked(string SelectedIndex)
{
    local int NextIndex, SelectedGearIndex;

    NextIndex = int(SelectedIndex);
    // End:0x121
    if((NextIndex >= 0) && NextIndex < ScrollerEntries.Length)
    {
        Outer.SelectedScrollerUnlock = ScrollerEntries[NextIndex].UnlockID;
        SelectedGearIndex = GearInfoArray[ScrollerEntries[NextIndex].InsertIndex].GearIndex;
        Outer.SelectedGearInfo = FoxDataProvider_GearInfo(GearInfoArray[SelectedGearIndex].GearProvider);
    }
    // End:0x141
    else
    {
        Outer.SelectedScrollerUnlock = 0;
    }
    super.ei_ScrollerClicked(SelectedIndex);
    //return;    
}

function NodeEquipButtonClicked(string SelectedIndex)
{
    local int NextIndex;

    NextIndex = int(SelectedIndex);
    // End:0xE9
    if((NextIndex >= 0) && NextIndex < ScrollerEntries.Length)
    {
        // End:0xE9
        if(ApplySelectedUnlock(GearInfoArray[ScrollerEntries[NextIndex].InsertIndex].GearIndex, Outer.CachedGearSlot))
        {
            Outer.UpdateCharacterGear(Outer.CachedGearSlot);
        }
    }
    super.NodeEquipButtonClicked(SelectedIndex);
    //return;    
}

function SetRenderToTextureActor(out ScrollerListEntry CurrentScrollerEntry, GearInfo CurrentGearInfo)
{
    //return;    
}

defaultproperties
{
    NodeWidgetClickFunc="ei_characterNodeClicked"
    bComponentSlots=true
}